#include "anim.h"
#include "base.h"

#include <sys/stat.h>

#include <kprocess.h>

int		anim::callscript(char *fn,char *tmpdir)
{
	FILE		*fp = 0;
	char		str[2048],*st = 0;
	int		len,ilen,t,i;

	KProcess	proc;

	for(t = 0;t < scriptlist.length();t++)
		if(strcmp(scriptlist[t]->name(),fn) == 0)
		{
			st = scriptlist[t]->scripttext();
		}

	if(st == 0) return -1;

	do
	{
		if(fp) fclose(fp);
		sprintf(str,"%s/tmp%i.sh",tmpdir,rand());
	}
	while((fp = fopen(str,"r")) != 0);	

	umask(0700);

	fp = fopen(str,"w");
	if(fp == 0) return -2;
	len = strlen(st);
	ilen = fwrite(st,1,len,fp);
	fclose(fp);

	if(ilen != len) return -3;

	proc << str;

	proc.start(KProcess::DontCare,(KProcess::Communication)(KProcess::Stdin | KProcess::Stdout));

	while(proc.isRunning())
	{
		gets(str);
		if(strncmp(str,"command",7) == 0)
		{
			char	*object,*command,*pstr[8];
			int	t;
			param	*p[8];

			object = strtok(str + 7," \n");
			command = strtok(0," \n");
			t = 0;
			while(t < 8 && (pstr[t] = strtok(0," \n"))) t++;

			for(i = 0;i < t;i++)
			{
				makeParam(&p[i],pstr[i]);
			}

			if(strncmp(object,"THIS",4) == 0)
			{
				call(command,0,p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
			}
			else
			{
				base	*bp2;

				//bp2 = ((base*)this)->search(object);
				if(bp2)
				{
					//bp2->call(command,0,p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
				}
			}
		}
	}
	return 0;
}


#ifdef TEST_ANIM

class base : public anim
{
public:

	base() : anim()
	{
		//addMethod("name");
		//addMethod("setname");
	}
};


class box : public base
{
	Vector3		v;

public:

	box() : base()
	{
		v = Vector3(0,0,0);
		addMethod("scale",(methodfn)&box::scale);
		addMethod("rotate",(methodfn)&box::rotate);
		addMethod("translate",(methodfn)&box::translate);
	}

	int	scale(param *,param *p)
	{
		Vector3		vv;

		if(p == 0 || p->type() != 5) return -1;

		vv = ((pmvector*)p)->vector();

		printf("scaling (%g,%g,%g)\n",vv(0),vv(1),vv(2));

		return 0;
	}
	int	rotate(param *,param *p)
	{
		Vector3		v;

		if(p == 0 || p->type() != 5) return -1;

		v = ((pmvector*)p)->vector();

		printf("rotating (%g,%g,%g)\n",v(0),v(1),v(2));

		return 0;
	}
	int	translate(param *,param *p)
	{
		Vector3		v;

		if(p == 0 || p->type() != 5) return -1;

		v = ((pmvector*)p)->vector();

		printf("translating (%g,%g,%g)\n",v(0),v(1),v(2));

		return 0;
	}
};

int	main()
{
	box	b;

	b.listMethods();

	b.call("m1",0,&pmvector(Vector3(0,0,0)));
	b.call("scale",0,&pmvector(Vector3(1,1,1)));
	b.call("rotate",0,&pmvector(1,0,2));
	b.call("translate");

	return 0;
}

#endif

