#include "animscript.h"

void	animscript(char *script)
{
	char		line[2048];
	char		*cp,*tok,*nm,*hp,*vp;
	int		t;

	var_t		v[1000];
	int		vc = 0;

	if(script == 0) return;

	cp = script;
	while(*cp != '\0')
	{
		// extract line by line from script
		for(t = 0;*cp != '\n' && *cp != '\0';cp++,t++)
		{
			line[t] = *cp;
		}

		// parse line
		tok = strtok(line," \t\n\0");
		if(tok)
		{
			nm = strtok(0," \t\n\0");
			if(nm)
			{
				if(strcmp(tok,"bool") == 0)
				{
					v[vc].name = strdup(nm);
					v[vc].type = 2;
					if((hp = strtok(0," \t\n\0)))
					{
						if(*hp == '=' && (vp = strtok(0," \t\n\0)))
						{
							v[vc].data.dbool = !(strcmp(vp,"FALSE") == 0 || strcmp(vp,"0") == 0);
						}
					}				
					vc++;
				}
				if(strcmp(tok,"int") == 0)
				{
					v[vc].name = strdup(nm);
					v[vc].type = 3;
					if((hp = strtok(0," \t\n\0)))
					{
						if(*hp == '=' && (vp = strtok(0," \t\n\0)))
						{
							v[vc].data.dint = strtoi(vp);
						}
					}				
					vc++;
				}
				if(strcmp(tok,"real") == 0)
				{
					v[vc].name = strdup(nm);
					v[vc].type = 4;
					if((hp = strtok(0," \t\n\0)))
					{
						if(*hp == '=' && (vp = strtok(0," \t\n\0)))
						{
							v[vc].data.dreal = strtod(vp);
						}
					}				
					vc++;
				}
				if(strcmp(tok,"vector") == 0)
				{
					v[vc].name = strdup(nm);
					v[vc].type = 5;
					if((hp = strtok(0," \t\n\0)))
					{
						if(*hp == '=' && (vp = strtok(0," \t\n\0)))
						{
							double		x,y,z;

							sscanf(vp,"<%f,%f,%f>,&x,&y,&z):
							v[vc].data.dvector = Vector3(x,y,z);
						}
					}				
					vc++;
				}
				if(strcmp(tok,"object") == 0)
				{
					v[vc].name = strdup(nm);
					v[vc].type = 6;
					v[vc].data.dobject = 0;
					if((hp = strtok(0," \t\n\0)))
					{
						if(*hp == '=' && (vp = strtok(0," \t\n\0)))
						{
							v[vc].data.dobject = strdup(vp);
						}
					}				
					vc++;
				}
			}
		}
	}
}

int	count(char *block,char open,char close)
{
	int	c;

	c = 0;
	while(*block != 0)
	{
		if(*block == open) c++;
		if(*block == close) c--;
		block++;
	}
	return c;
}

char	*getnextblock(char *gblock)
{
	char	*inblock,*cp,*cp2;

	if((count(gblock,'{','}') & 1) == 1) return 0;
	if(count(gblock,'{','}') == 0) return gblock;

	inblock = gblock;
	cp = inblock + 1;
	while(strchr(" \t\n",*cp) != 0) cp++;
	cp2 = inblock + strlen(inblock) - 1;
	while(strchr(" \t\n",*cp2) != 0) cp2--;
	inblock = (char*)malloc(cp2 - cp + 1);
	memcpy(inblock,cp,cp2 - cp);
	inblock[cp2 - cp] = 0;

	return inblock;
}

int	testblock(char *block)
{
	int	bid;

	if(strncmp("bool",block,4) == 0) bid = 0;
	else if(strncmp("char",block,4) == 0) bid = 0;
	else if(strncmp("int",block,3) == 0) bid = 0;
	else if(strncmp("real",block,4) == 0) bid = 0;
	else if(strncmp("vector",block,6) == 0) bid = 0;
	else if(strncmp("object",block,6) == 0) bid = 0;
	else
	{
		bid = 1;
	}

	return bid;
}


int	adddim(char *block,int depth)
{
	printf("addim: %s\n",block);

	return -1;
}

int	evalblock(char *block,int depth)
{
	printf("evalblock: %s\n",block);

	return -1;
}

int	parseblock(char *gblock,int depth)
{
	char	*block;

	while((block = getnextblock(gblock)) != 0)
	{
		switch(testblock(block))
		{
			case 0: // DIM-Block
				adddim(block,depth);
			break;
			case 1: // EVAL-Block
				evalblock(block,depth);
			break;
		}
	}
	if(block) free(block);

	return 0;
}

	


