// perl-embed-test

#include <EXTERN.h>               /* from the Perl distribution     */
#include <perl.h>                 /* from the Perl distribution     */

static PerlInterpreter *my_perl;  /***    The Perl interpreter    ***/

void	CallFromPerl()
{
	printf("Called from Perl\n");
}

void	WorldMain(int timestep,int frame)
{
	dSP;
	ENTER;					/* everything created after here */
	SAVETMPS;				/* ...is a temporary variable.   */
	PUSHMARK(sp);				/* remember the stack pointer    */
	XPUSHs(sv_2mortal(newSViv(timestep)));	/* push the timestep onto the stack  */
	XPUSHs(sv_2mortal(newSViv(frame)));	/* push the frame onto stack  */
	PUTBACK;				/* make local stack pointer global */
	perl_call_pv("main", G_SCALAR);		/* call the function             */
	SPAGAIN;				/* refresh stack pointer         */
						/* pop the return value from stack */
//	printf ("%d to the %dth power is %d.\n", a, b, POPi);
	PUTBACK;
	FREETMPS;				/* free that return value        */
	LEAVE;					/* ...and the XPUSHed "mortal" args.*/
}

int main()
{
	char		*embedding[] = {"","-e","0"};
	char		perlfunction[] = "sub main { " \
					"my($timestep,$frame) = @_;" \
					"print \"timestep \",$timestep,\" ms\n\";" \
					"print \"frame #  \",$frame,\"\n\";" \
					"print \"time     \",$frame * $timestep / 1000,\" sec\n\";" \
					"}";

	my_perl = perl_alloc();
	perl_construct(my_perl);
	perl_parse(my_perl, NULL, 3, embedding, (char **)NULL);
	perl_run(my_perl);

	perl_eval_pv(perlfunction, TRUE);
	//printf("a = %d\n", (int)SvIV(perl_get_sv("a", FALSE)));

	WorldMain(40,0);
	WorldMain(40,12);
	WorldMain(40,25);
	WorldMain(40,37);

	perl_destruct(my_perl);
	perl_free(my_perl);
}

