#ifndef __BLOB_H__
#define __BLOB_H__

#include "csgobj.h"
#include "blobobj.h"

class blob : public csgobj
{
protected:
	list<blobobj*>	bloblist;
	double		threshold;

public:
	blob(base *p=0,char *n="Untitled",double treshhold = 0.5,texture *t=0);
	blob(base *p,char *n,double tr,texture *t,Vector3&,Vector3&,Vector3&);
	blob(base *p,char *n,double tr,Vector3&,Vector3&,Vector3&);
	blob(base *p,blob *bc);
	~blob();

	double		thresholdValue()
	{
		return threshold;
	}
	void		setThresholdValue(double t)
	{
		threshold = t;
	}

	virtual int	addToParent(base*);
	virtual int	removeFromParent();

	virtual base	*copy(base*);

	virtual int	exportPOV(FILE*,int,int);
	virtual void	dumpNames(int,int);

	virtual int	addChild(blobobj*);
	virtual int	removeChild(blobobj*);

	virtual void	getChildren(base ***b)
	{
		int	t;
		base	**bt;

		*b = NULL;
		bt = (base**)malloc(sizeof(base*) * (bloblist.length() + 2));
		if(!bt) return;

		for(t = 0;t < bloblist.length();t++)
			bt[t] = bloblist[t];
		bt[t] = NULL;
		*b = bt;
	}

	virtual int	save(FILE*);
	virtual int	load(FILE*,int);

	virtual	base	*searchName(char *n);
	virtual int	existsName(char *n);

	virtual int	draw(view *v,Matrix44);
	virtual int	calculate();
};

#endif
