#include "body.h"
#include "world.h"

body::body(base *p,char *n,texture *t)
 : dim(p,n)
{
	texptr = t;
}

body::body(base *p,char *n,texture *t,Vector3 &vs,Vector3 &vr,Vector3 &vt)
 : dim(p,n,vs,vr,vt)
{
	texptr = t;
}

body::body(base *p,char *n,Vector3 &vs,Vector3 &vr,Vector3 &vt)
 : dim(p,n,vs,vr,vt)
{
	texptr = 0;
}

body::body(base *p,body *bc)
 : dim(p,(dim*)bc)
{
	texptr = bc->texptr;
}

body::~body()
{
}

void		body::setTexture(texture *t)
{
	texptr = t;
}

texture		*body::getTexture()
{
	return texptr;
}

int		body::saveTexture(FILE *fp)
{
	if(texptr)
	{
		texptr->savePtr(fp);
	}

	return 0;
}

int		body::loadTexture(FILE *fp,int)
{
	char		chunk[4],*tn;
	int		len = 0;

	fread(chunk,1,4,fp);
	fread(&len,1,4,fp);

	if(strncmp(chunk,"TXTP",4) != 0) return -1;

	tn = readName(fp);

	texptr = findTexture(tn);

	return 0;
}

texture		*body::findTexture(char *n)
{
	world		*myworld;
	base		*b;
	texturemap	*tm;

	if(n == 0) return 0;
//	if((b = getRoot()) == 0) return 0;
//	Do not need the root, need the world
	for(b = this;b->getParent() && b->getType() != NUM_WORLD;b = b->getParent());

	if(b->getType() != NUM_WORLD) return 0;

	myworld = (world*)b;
	if((tm = myworld->getTextureMap()) == 0) return 0;

	return tm->findTexture(n);
}




