#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "csgobj.h"

csgobj::csgobj(base *p,char *n,texture *t) :
	atom(p,n,t)
{
	numtype = NUM_CSGOBJ;
}

csgobj::csgobj(base *p,char *n,Vector3 &vs,Vector3 &vr,Vector3 &vt) :
	atom(p,n,vs,vr,vt)
{
	numtype = NUM_CSGOBJ;
}

csgobj::csgobj(base *p,char *n,texture *t,Vector3 &vs,Vector3 &vr,Vector3 &vt) :
	atom(p,n,t,vs,vr,vt)
{
	numtype = NUM_CSGOBJ;
}

csgobj::csgobj(base *p,csgobj *cc) :
	atom(p,cc->getName(),cc->getTexture(),cc->getVScale(),cc->getVRotate(),cc->getVTranslate())
{
	numtype = NUM_CSGOBJ;
}

csgobj::~csgobj()
{
	removeFromParent();
}

void	csgobj::dumpNames(int tab,int)
{
	printTab(stdout,tab);
	printf("csgobj: %s\n",name);
}

int	csgobj::addToParent(base *p)
{
	if(!p) return -2;

	parent = p;
	return p->addChild(this);
}

int	csgobj::removeFromParent() 
{ 
	if(!parent) return -2; 
	return parent->removeChild(this); 
} 


