#ifndef __DIM_H__
#define __DIM_H__

#define DIMSAVE()	{SV(vscale);SV(vrotate);SV(vtranslate);}

#include <stdio.h>
#include "num.h"
#include "list.h"
#include "base.h"

class dim : public base
{
protected:
	Vector3		vscale,vrotate,vtranslate;

public:
	dim(base *p = NULL,char *n="Untitled");
	dim(base *p,char *n,Vector3&,Vector3&,Vector3&);
	dim(base *p,dim *);
	~dim();

	void		translate(Vector3 v);
	void		rotate(Vector3 v);
	void		scale(Vector3 v);
	void		scale(double d);

	Vector3		&getVScale()
	{
		return vscale;
	}
	Vector3		&getVRotate()
	{
		return vrotate;
	}
	Vector3		&getVTranslate()
	{
		return vtranslate;
	}
	void		setVScale(Vector3 &v)
	{
		vscale = v;
	}
	void		setVRotate(Vector3 &v)
	{
		vrotate = v;
	}
	void		setVTranslate(Vector3 &v)
	{
		vtranslate = v;
	}

	void		dimMatrix(Matrix44 &m);

	virtual int	addToParent(base*) = 0;
	virtual int	removeFromParent() = 0;

	virtual base	*copy(base *parent) = 0;

	virtual int	exportPOV(FILE*,int tab,int tabsize) = 0;

	virtual void	dumpNames(int tab,int tabsize) = 0;

	virtual int	save(FILE*);
	virtual int	load(FILE*,int);

	//virtual int	paint();
};

#endif	
