#ifndef __HEIGHTFIELD_H__
#define __HEIGHTFIELD_H__

#include "csgobj.h"
#include <g++/bool.h>

class heightfield:public csgobj
{
protected:
	char	*filename;
	int	hierarchy;
	int	smooth;
	double	water_level;

public:
	heightfield(base *b=0,char *n="Untitled",char *fn="",bool h=FALSE,bool s=FALSE,double wl=0,texture *t=0);
	heightfield(base*,char*,char*,bool,bool,double,Vector3&,Vector3&,Vector3&);
	heightfield(base*,char*,char*,bool,bool,double,texture*,Vector3&,Vector3&,Vector3&);
	heightfield(base*,heightfield*);
	~heightfield();

	virtual int exportPOV(FILE *, int, int);
	virtual int save(FILE *);
	virtual int load(FILE *,int);

	virtual int addToParent(base *o);
	virtual int removeFromParent();

	virtual base	*copy(base*);

	virtual void dumpNames(int, int);

	virtual int	draw(view *,Matrix44)
	{
		printf("not implemented\n");
		return -3;
	}
	virtual int	calculate() {return 0;};

};

#endif
