#ifndef __LIGHTPOINT_H__
#define __LIGHTPOINT_H__


#include "lightobj.h"


class lightpoint : public lightobj
{
protected:
	double r,g,b;
	double fade_distance;
	double fade_power;
	int atmos_attenuation;

public:
	lightpoint(base *p=0,char *n="Untitled");
	lightpoint(base *p,char *n,Vector3&,Vector3&,Vector3&);
	lightpoint(base *p,lightpoint *lc);
	~lightpoint();

	void SetColor(double, double, double);
	void SetFadeDistance(double);
	void SetFadePower(double);
	void SetAtmosAtt(int);

	virtual int	addToParent(base *p);
	virtual int	removeFromParent(); 

	virtual base	*copy(base*);

	virtual int	exportPOV(FILE *f, int tab, int tabsize);
	virtual void	dumpNames(int tab, int tabsize);
	
	virtual int	save(FILE *);
	virtual int	load(FILE *, int);

	virtual int	draw(view*,Matrix44);
	virtual int	calculate()
	{
		vmin = vmax = Vector3(0,0,0);

		return 0;
	};
	virtual int	isFinite() {return 0;};
};

#endif	
