#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nonsolid.h"

nonsolid::nonsolid(base *p,char *n,texture *t) :
	atom(p,n,t)
{
	numtype = NUM_NONSOLID;
}

nonsolid::nonsolid(base *p,char *n,Vector3 &vs,Vector3 &vr,Vector3 &vt) :
	atom(p,n,vs,vr,vt)
{
	numtype = NUM_NONSOLID;
}

nonsolid::nonsolid(base *p,char *n,texture *t,Vector3 &vs,Vector3 &vr,Vector3 &vt) :
	atom(p,n,t,vs,vr,vt)
{
	numtype = NUM_NONSOLID;
}

nonsolid::nonsolid(base *p,nonsolid *ns) :
	atom(p,(atom*)ns)
{
	numtype = NUM_NONSOLID;
}

nonsolid::~nonsolid()
{
	removeFromParent();
}

void	nonsolid::dumpNames(int tab,int)  
{ 
	printTab(stdout,tab); 
	printf("nonsolid: %s\n",name); 
} 

int	nonsolid::addToParent(base *p) 
{ 
	if(!p) return -2; 

	parent = p;
	return p->addChild(this); 
}

int	nonsolid::removeFromParent()  
{  
	if(!parent) return -2;  
	return parent->removeChild(this);  
}


