#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "num.h"
#include "math.h"
#include "quartic.h"

quartic::quartic(base *p,char *n ) :
	csgobj(p,n)
{
	int i;

	numtype = NUM_QUARTIC;
	count = 0;
	for(i = 0;i < 34;i++)
	{
		koeff[i] = 0;
	}
	if(parent)
		addToParent(parent);
}

quartic::~quartic()
{
}

int quartic::addToParent(base *p) 
{ 
	if (!p) return -2; 
	return p->addChild(this); 
} 
 
void quartic::dumpNames(int tab,int) 
{ 
	printTab(stderr,tab); 
	printf("poly: %s\n", name); 
} 

void quartic::AddKoeff(double k)
{
	if (count==34) { return;}
	koeff[count++]=k;
}

void quartic::Reset()
{
int i;
	for (i=0;i<34;i++) {koeff[i]=0;}
	count=0;
}

int	quartic::exportPOV(FILE *fp,int tab,int tabsize)
{
int i;

	printTab(fp,tab);
	fprintf(fp,"// Objectname = %s\n",name);
	printTab(fp,tab);
	fprintf(fp,"// Objecttype = quartic\n");
	printTab(fp,tab);
	fprintf(fp," quartic { < ");
	for (i=0;i<34;i++) {
		fprintf(fp," %f, ",koeff[i]);
	}
	fprintf(fp,"%f > \n",koeff[count]);

	dim::exportPOV(fp,tab,tabsize);

	printTab(fp,tab);
	fprintf(fp,"}\n\n");

	return 0;
}

int	quartic::save(FILE *fp)
{
	int i;

	if (!fp) return -1;
	setFile(fp);
	writeChunk("QART");
	SN(name);
	for (i=0;i<34;i++) { SD(koeff[i]); }
	dim::save(fp);
	writeChunkLen();

	return 0;
}

int	quartic::load(FILE *fp, int l)
{
	int i;

	for (i=0;i<34;i++) { koeff[i]=readDouble(fp); }
	dim::load(fp,l);

	return 0;	
}

/*
void main()
{
FILE *file;
cubic l;
	file=fopen("test","w+");
	l.AddKoeff(1);
	l.AddKoeff(2);
	l.AddKoeff(3);
	l.exportPOV(file,2,2);
	fclose(file);
}*/
