#ifndef __REFPTR_H__
#define __REFPTR_H__

#include "atom.h"
#include "ref.h"

class refptr : public atom
{
protected:
	ref		*refp;
	char		*tmpname;

public:
	refptr(base *p=0,char *n="Untitled",texture *t=0);
	refptr(base *p,char *n,Vector3&,Vector3&,Vector3&);
	refptr(base *p,char *n,texture *t,Vector3&,Vector3&,Vector3&);
	refptr(base *p,refptr *rc);
	~refptr();

	virtual int	addToParent(base *);
	virtual int	removeFromParent();

	virtual base	*copy(base*);

	virtual int	addChild(ref *);
	virtual void	getChildren(base***);

	virtual int	exportPOV(FILE*,int,int);

	virtual void	dumpNames(int,int);

	virtual int	save(FILE*);
	virtual int	load(FILE*,int);

	base		*getPTR();
	char		*getPTRName();

	virtual int	draw(view*,Matrix44);
	virtual int	calculate();
};

#endif

