#ifndef __SPOTLIGHT_H__
#define __SPOTLIGHT_H__

#include "lightobj.h"


class spotlight : public lightobj
{
protected:
	double r,g,b;
	double fade_distance;
	double fade_power;
	int atmos_attenuation;
	Vector3 point_at;
	double radius, falloff, tightness;

public:
	spotlight(base *p=0,char *n="Untitled");
	spotlight(base*,char*,Vector3&,Vector3&,Vector3&);
	spotlight(base*,spotlight*);
	~spotlight();

	virtual base	*copy(base*);

	void SetColor(double, double, double);
	void SetFadeDistance(double);
	void SetFadePower(double);
	void SetAtmosAtt(int);
	void SetPointAt(Vector3 );
	void SetPointAt(double, double, double);
	void SetTightness(double);
	void SetRadius(double);
	void SetFallOff(double);

	virtual int	addToParent(base *p);
	virtual int	removeFromParent();

	virtual int	exportPOV(FILE *f, int tab, int tabsize);
	virtual void	dumpNames(int tab, int tabsize);

	virtual int	save(FILE *);
	virtual int	load(FILE *, int);

	virtual int	draw(view*,Matrix44);
	virtual int	calculate()
	{
		vmin = vmax = Vector3(0,0,0);

		return 0;
	};
	virtual int	isFinite() { return 0;};
};

#endif	
