#ifndef __TEXT_H__
#define __TEXT_H__

#include <font.h>

#include "csgobj.h"

class text : public csgobj
{
protected:
	char		*fontname;
	char		*context;
	double		thickness;	// z-Ausdehnung
	Vector2		offset;		// default:0, ansonsten Buchstabenabstand fr x und y

	fontglyph	**fontcache;
	font		*fontptr;

public:

	text(base *b=0,char *n="Untitled",char *tx="Text",char *f="arial.ttf",double th=1,texture *t=0);
	text(base*,char*,char*,char*,double,Vector2&,texture*,Vector3&,Vector3&,Vector3&);
	text(base*,char*,char*,char*,double,Vector2&,Vector3&,Vector3&,Vector3&);
	text(base*,text*);
	~text();

	virtual int	addToParent(base *p);
	virtual int	removeFromParent();

	virtual base	*copy(base*);

	virtual int	exportPOV(FILE *,int,int);
	virtual void	dumpNames(int,int);

	virtual int	save(FILE*);
	virtual int	load(FILE*,int);

	virtual int	draw(view*,Matrix44);
	virtual int	calculate();

	char	*getText()
	{
		return context;
	}
	void	setText(char *txt)
	{
		if(context) free(context);
		context = strdup(txt);
	}
	char	*getFontName()
	{
		return fontname;
	}
	void	setFontName(char *fn)
	{
		if(fontname) free(fontname);
		fontname = strdup(fn);
		if(fontptr) fontptr->setFileName(fontname);
	}
	double	getThickness()
	{
		return thickness;
	}
	void	setThickness(double t)
	{
		thickness = t;
	}
	Vector2	getOffset()
	{
		return offset;
	}
	void	setOffset(Vector2 &o)
	{
		offset = o;
	}

	void	setFontPath(char*)
	{
	}

private:
	int		drawSpline(view*,Matrix44,Vector2*,int,double,double);
};

#endif


