#ifndef __TORUS_H__
#define __TORUS_H__

#include "csgobj.h"

class torus : public csgobj
{
protected:
	double major;
	double minor;

public:
	torus(base *b=0,char *n="Untitled",double r1=1,double r2=0.5,texture *t=0);
	torus(base *b,char *n,double r1,double r2,Vector3&,Vector3&,Vector3&);
	torus(base *b,char *n,double r1,double r2,texture *t,Vector3&,Vector3&,Vector3&);
	torus(base *b,torus *tc);
	~torus();

	virtual int	addToParent(base *p);
	virtual int	removeFromParent();

	virtual base	*copy(base *);

	virtual int	exportPOV(FILE *,int,int);
	virtual void	dumpNames(int,int);

	virtual int	save(FILE*);
	virtual int	load(FILE*,int);

	virtual int	draw(view*,Matrix44);
	virtual int	calculate();
};

#endif
