#ifndef __TRIANGLE_H__
#define __TRIANGLE_H__

#include "nonsolid.h"

class triangle : public nonsolid
{
protected:

	Vector3 edge1,edge2,edge3;
	Vector3 n1,n2,n3;
	int smooth;
	
public:
	triangle(base*p=0,char *n="Untitled",double x1=1,double y1=0,double z1=0,double x2=0,double y2=1,double z2=0,double x3=0,double y3=0,double z3=1,int s=0,texture *t=0);
	triangle(base *p,char *n,Vector3 &v1,Vector3 &v2,Vector3 &v3,texture *t);
	triangle(base *p,char *n,Vector3&,Vector3&,Vector3&);
	triangle(base *p,char *n,texture *t,Vector3&,Vector3&,Vector3&);
	triangle(base *p,triangle *tc);
	~triangle();

	int		setNormal(Vector3 v1,Vector3 v2, Vector3 v3, int s);
	int		setNormal(double x1, double y1, double z1, double x2, double y2, double z2, double x3, double y3, double z3, int s);

	virtual int	exportPOV(FILE* f=NULL, int a=2, int b=2);
	virtual int	save(FILE *);
	virtual int	load(FILE *,int );

	virtual int	addToParent(base*);
	virtual int	removeFromParent();

	virtual base	*copy(base*);

	virtual void	dumpNames(int, int);

	virtual int	draw(view *,Matrix44);
	virtual int	calculate();
};


#endif
