#ifndef __COLOR_H__
#define __COLOR_H__

#include <misc.h>
#include <list.h>

#include <stdio.h>

class color
{
protected:

	double	r,g,b,t,v;

public:

	color(double r = 0,double g = 0,double b = 0,double t = 0,double v = 0);
	~color();

	double	red();
	double	green();
	double	blue();
	double	transparency();
	double	value();

	void	setRed(double);
	void	setGreen(double);
	void	setBlue(double);
	void	setTranparency(double);
	void	setValue(double);

	int	save(FILE*);
	int	load(FILE*,int);

	int	exportPOV(FILE*,int,int,int with_tr = 0,int am = 0);
};

class colormap : public list<color>
{
public:

	colormap();

	void		addColor(color);
	void		removeColor(int);
	color		&getColor(int);
	color		getColor(double);
	int		getColorIndex(double);
	int		entries();

	int		save(FILE*);
	int		load(FILE*,int);

	int		exportPOV(FILE*,int,int);

	void	sort();

};


#endif


