#ifndef __PIGMENT_H__
#define __PIGMENT_H__

#include "color.h"
#include <chunk.h>

class pigment : public colormap, public chunk
{
public:

	enum FUNCTION
	{
		Checker,
		Marble,
		Wood,
		Granite,
		Leopard,
		Onion,
		Brick,
		Hexagon,
		Agate,
		Average,
		Crackle,
		Dents,
		Mandel,
		Waves,
		Spotted,
		Ripples,
		Gradient,
		Radial,
		Spiral1,
		Spiral2,
		Bozo,
		Bumps,
		Wrinkles,
		NFunctions
	};

protected:

	FUNCTION	fn;
	double		turb;

public:

	pigment();

	void		setFunction(FUNCTION f);
	void		setTurbulence(double t);

	double		turbulence();
	int		function();

	char		*getFunctionName(FUNCTION);

	int		load(FILE*,int);
	int		save(FILE*);

	int		exportPOV(FILE*,int,int);

};


#endif



