#ifndef __TEXTURE_H__
#define __TEXTURE_H__

#include "pigment.h"

#define MAP_PLANAR	1
#define MAP_SPHERE	2
#define MAP_CYLINDER	3
#define MAP_DONUT	4

class texture : public pigment
{
protected:
	char		*name;

	double		r,g,b;
	int		colorMapMapping; 
	char		*colorMapName;

public:
	texture(char *n,double r,double g,double b);
	texture(char *n = "Untitled");
	~texture();

	char		*getName();
	int		setName(char *n);

	void		setColorMapMapping(int);
	int		setColorMapName(char*);

	int 		getColorMapMapping() { return colorMapMapping;}
	char		*getColorMapName() { return colorMapName; }	

	int		save(FILE*);
	int		load(FILE*,int);
	int		savePtr(FILE*);
	int		loadPtr(FILE*,int);

	int		exportPOV(FILE*,int,int);
};

#endif

