// texturemap.h
//
// Diese Klasse ist nur eine virtuelle Klasse (z.B. fr KDE)
// Sie ermglicht eine Hierachische Katalog mit mehreren Seiten
// So knnte so ein Katalog so aussehen:
//
// Basiskatalog
//  - POV-katalog
//   - Stein
//   - Holz
//  - k3de-katalog
//   - Stein
//   - Holz
//   - Haut
//   - Transpatenz
//  - eigener Katalog
//   - Stein
//   - Holz
//   - Haut

#ifndef __TEXTUREMAP_H__
#define __TEXTUREMAP_H__

#include <list.h>
#include "texture.h"
#include <chunk.h>

class texturemap : public chunk
{
protected:

	char			*_name;
	list<texture*>		texturelist;
	list<texturemap*>	texturemaplist;

public:

	texturemap(char *n);
	~texturemap();

	char		*name();
	texture		*findTexture(char*);
	char		*texturePath(char*);

	void		addTexture(texture*);
	void		addTexturemap(texturemap*);

	void		removeTexture(texture*);
	void		removeTexturemap(texturemap*);

	int		getNumTextures();
	texture		*getTexture(int);
	texture		*getFirstTexture();
	texture		*getNextTexture();

	int		getNumTextureMaps();
	texturemap	*getTextureMap(int);
	texturemap	*getFirstTexturemap();
	texturemap	*getNextTexturemap();

	int		save(FILE*);
	int		load(FILE*,int);
};

#endif



