#ifndef __K3DE_DIALOG__
#define __K3DE_DIALOG__

#include "../texture/texturecolor.h"

#include <qdialog.h>
#include <qlineedit.h> 
#include <qlabel.h> 
#include <qtabdialog.h>
#include <qpushbutton.h>

#include <kcolorbtn.h> 
#include <kcombo.h>


#include <texture.h>


class TextureColor;

class	TextureDialog : public QDialog
{
Q_OBJECT

protected:
	QTabDialog		*tabdialog;
	QPushButton		*ok,*cancel;
	TextureColor		*color;
	QLabel			*namelabel;
	QLineEdit		*nameline;

	texture			*txtptr;

public:
	TextureDialog(QWidget *parent,const char *name,texture *t);
	~TextureDialog();

	texture		*getTexture();

protected:

	void		paintEvent(QPaintEvent *);
};

class	NameDialog : public QDialog
{
Q_OBJECT

protected:
	QPushButton	*ok,*cancel;
	QLineEdit	*line;

public:
	NameDialog(QWidget *parent,const char *name);
	~NameDialog();

	QString		getName();
	void		setName(QString);

};

class	BlobDialog : public QDialog
{
Q_OBJECT

protected:
	QPushButton	*ok,*cancel;
	QLineEdit	*line;
	QLabel		*label;

public:
	BlobDialog(QWidget *parent,const char *name);
	~BlobDialog();

	double		thresholdValue();
	void		setThresholdValue(double);

};

#include "dimwidget.h"

class	DimDialog : public QDialog
{
Q_OBJECT

protected:
	QPushButton	*ok,*cancel;
	DimWidget	*dimw;

public:
	DimDialog(QWidget *parent,const char *name);
	~DimDialog();

	void	save(Vector3 &s,Vector3 &r,Vector3 &t);
	void	load(Vector3 s,Vector3 r,Vector3 t);
};

class	TextDialog : public QDialog
{
Q_OBJECT

protected:
	QPushButton	*ok,*cancel;
	QLineEdit	*wcontext,*wfontname,*wthickness,*wxoffset,*wyoffset;
	QLabel		*lcontext,*lfontname,*lthickness,*loffset;

public:
	TextDialog(QWidget *parent,const char *name);
	~TextDialog();

	void	save(QString &context,QString &fontname,double &thickness,Vector2 &offset);
	void	load(QString context,QString fontname,double thickness,Vector2 offset);
};


#endif

