#ifndef __TEXTURETABLE_H__
#define __TEXTURETABLE_H__

#include "selecttable.h"
#include <texture.h>
#include <texturemap.h>

class TextureTable;

class TextureTableItem : public SelectTableItem
{
protected:

	const texture	*texptr;

public:

	TextureTableItem(TextureTable *parent,int id=-1,const char *title=0,QPixmap &p=0,texture *t=0,int add=1);
	~TextureTableItem();

	void		setTexture(const texture *t);
	const texture	*getTexture() const;
};

class TextureTable : public SelectTable
{
Q_OBJECT

protected:

	texturemap	*tmap;

public:

	TextureTable(QWidget *parent = 0,const char *name = 0,WFlags f=0,texturemap *t=0);
	~TextureTable();

	bool			insertItem(TextureTableItem *);
	TextureTableItem	*item(int id);

	texturemap		*getTextureMap();

signals:

	void			setTexture(texture *);

private slots:

	void			selectedTexture(int);
	void			setTextureMap(texturemap *tm);

};


#endif


