#include "colorflowwidget.h"
#include "colorflowwidget.moc"

#include <stdio.h>

ColorFlowWidget::ColorFlowWidget(QWidget *p) :
	QFrame(p), colormap()
{
	qp = new QPainter(this);
	setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
	setLineWidth(2);
}

ColorFlowWidget::~ColorFlowWidget()
{
	delete qp;
}

	
void	ColorFlowWidget::paintEvent(QPaintEvent*)
{
	paint();
}

int	ColorFlowWidget::topValue()
{
	return width() - 4;
}

void	ColorFlowWidget::paint()
{
	int		t;
	double		v,dr,dg,db;
	QColor		qc;
	color		c;

	for(t = 0;t < topValue();t++)
	{
		v = (double)t / (double)(topValue() - 1);
		c = getColor(v);
		dr = c.red() * 255;
		dg = c.green() * 255;
		db = c.blue() * 255;

		qc.setRgb((int)dr,(int)dg,(int)db);		
		qp->setPen(qc);
		qp->drawLine(t + 2,2,t + 2,height() - 4);
	}
	drawFrame(qp);
}




