#include "texturecolor.h"
#include "texturecolor.moc"

#include <klocale.h>

#include <qslider.h>

//#define stloc(a)	((char*)locale->translate((a)))
#define stloc(a) (a)


TextureColor::TextureColor(QWidget *parent,const char *name,texture *t) :
	QWidget(parent,name)
{
	int		i;

	txtptr = t;

	cmw = new ColorMapWidget(this);
	map = new TexturePixmap(this,name,t);

	fnlabel = new QLabel(this);
	fnlabel->setText("Function:");

	fncombo = new QComboBox(this);
	for(i = 0;i < pigment::NFunctions;i++)
		fncombo->insertItem(txtptr->getFunctionName((pigment::FUNCTION)i),i);

	turblabel = new QLabel(this);
	turblabel->setText("Turbulence:");

	turbline = new QLineEdit(this);
	turbline->setText("0");

	if(txtptr->length() == 0)
	{
		cmw->addColor(color(0.5,0.5,0.5,0,0.5));
	}

	for(i = 0;i < txtptr->length();i++)
	{
		cmw->addColor(txtptr->at(i));
	}

}

TextureColor::~TextureColor()
{
}

void TextureColor::paintEvent(QPaintEvent*)
{
	int w,h,x,y;

	x = 5;
	y = 5;
	h = 55;
	w = width() - 10;
	cmw->setGeometry(x,y,w,h);

	y += h + 5;
	x = 5;
	w = (width() - 25) / 4;
	h = 25;
	fnlabel->setGeometry(x,y,w,h);

	x += 5 + w;
	fncombo->setGeometry(x,y,w,h);

	x += 5 + w;
	turblabel->setGeometry(x,y,w,h);

	x += 5 + w;
	turbline->setGeometry(x,y,w,h);

	y += h + 5;
	x = 5;
	w = width() - 10;
	h = height() - y - 5;
	map->setGeometry(x,y,w,h);
}

texture	*TextureColor::getTexture()
{
	int		t;
	color		c;
	double		d;
	QString		str;

	txtptr->empty();

	for(t = 0;t < cmw->nColors();t++)
	{
		c = cmw->getColor(t);
		printf("%i. color <%g,%g,%g,%g,%g>\n",
			t,c.red(),c.green(),c.blue()
			,c.transparency(),c.value());
		txtptr->append(c);
	}

	txtptr->setFunction((pigment::FUNCTION)fncombo->currentItem());
	str = turbline->text();
	d = str.toDouble();
	txtptr->setTurbulence(MAX(0,d));

	return txtptr;
}


