#include "texturepixmap.h"
#include "texturepixmap.moc"

#include <klocale.h>


//#define stloc(a)	((char*)locale->translate((a)))
#define stloc(a) (a)

TexturePixmap::TexturePixmap(QWidget *parent,const char *name,texture *t) :
	QWidget(parent,name)
{
	KLocale *locale;
	txtptr = t;

	box=new QGroupBox(this,name);
	box->setTitle( stloc("Pixmap") );

	previewLabel=new QLabel(box,name);
	previewPic=new QPixmap(1,1);
	previewLabel->setPixmap(*previewPic);

	fileEdit=new QLineEdit(box,name);
	fileButton=new  QPushButton(box,name);
	fileButton->setText("...");

	combo=new QComboBox(box,name);
	combo->insertItem((char *)stloc("planar") );
	combo->insertItem((char *)stloc("spherical") );
	combo->insertItem((char *)stloc("cylindric") );
	combo->insertItem((char *)stloc("donut") ); 

	filter=new QPushButton(box,name);
	filter->setText(stloc("Filter") );

	labelmap=new QLabel(box,name); 
	labelmap->setText(stloc("Mapping"));

	labelpix=new QLabel(box,name);
	labelpix->setText(stloc("Map:"));

	switch(mapping ) {
		case MAP_PLANAR:
			combo->setCurrentItem(0);	
		break;
		case MAP_SPHERE:
			combo->setCurrentItem(1);	
		break;
		case MAP_CYLINDER:
			combo->setCurrentItem(2);	
		break;
		case MAP_DONUT:
			combo->setCurrentItem(3);	
		break;

	}
	FilenameChanged(picname);

	connect(fileButton,SIGNAL(clicked()),this,SLOT(FileButtonPushed() ) );
	connect(filter,SIGNAL(clicked()),this,SLOT(FilterButtonPushed() ) );
	connect(combo,SIGNAL(activated(int)),this,SLOT(MappingButtonPushed(int) ) );
	connect(fileEdit,SIGNAL(textChanged(const  *char)),this,SLOT(FilenameChanged(const char *)) );
}


void TexturePixmap::MappingButtonPushed(int n)
{
	switch(n) {
		case 0:
			mapping=MAP_PLANAR;
		break;
		case 1:
			mapping=MAP_SPHERE;
		break;
		case 2:
			mapping=MAP_CYLINDER;
		break;
		case 3:
			mapping=MAP_DONUT;
		break;
	}
}

void TexturePixmap::FilterButtonPushed()
{
	printf("Not yet supported\n");
}

void TexturePixmap::FileButtonPushed()
{
QString fname = KFileDialog::getOpenFileName(picname,"*.gif,*jpeg,*jpg",this);
	if (fname.isNull() ) return;
	FilenameChanged(fname);
	fileEdit->setText(fname);
}

void TexturePixmap::FilenameChanged(const char *f)
{
QFontInfo ft=this->fontInfo();
int fontsize=ft.pointSize()+6;
	picname=f;
	if (previewPic->load(picname)==false) { printf("??\n"); } else { printf("okay\n"); } 
	printf("Mae : %d %d\n",previewPic->width(),previewPic->height() ) ;
	previewPic->resize(previewLabel->width()-fontsize,previewLabel->height()-fontsize );

	previewLabel->setPixmap(*previewPic);
	
}

TexturePixmap::~TexturePixmap()
{
	delete previewPic;
	delete fileEdit;
	delete fileButton;
	delete combo;
	delete filter;
	delete labelmap;
	delete labelpix;
	delete box;
}

void TexturePixmap::resizeEvent(QResizeEvent *pe)
{
QSize qs=pe->size();
QFontInfo ft=this->fontInfo();
int width=qs.width()-4;
int height=qs.height()-4;
int fontsize=ft.pointSize()+6;
int dummy;
	
	box->setGeometry(0,0,width,height);

	labelpix->setAutoResize(true);
	labelpix->move(5,20);

	fileEdit->resize(10*fontsize,fontsize);
	fileEdit->move(labelpix->x()+labelpix->width(),labelpix->y() );

	fileButton->resize(fontsize,fontsize);
	fileButton->move(2+fileEdit->x()+fileEdit->width(),fileEdit->y());
	
	labelmap->move(fileEdit->x(),fileEdit->y()+fileEdit->height()+15);
	labelmap->setAutoResize(true);

	combo->resize(fontsize*4,fontsize+4);
        	combo->move(labelmap->x()+labelmap->width()+3,labelmap->y() );

	filter->resize(fontsize*4,combo->height());
	filter->move(combo->x()+combo->width()+10,combo->y() );

	dummy=box->height()-15;
	previewPic->resize(dummy,dummy);	
	previewLabel->resize(dummy,dummy );
	previewLabel->move(box->width()-dummy-15,10 );
		
}





