#ifndef __CHUNK_H__
#define __CHUNK_H__

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "matmath.h"

#define SN(a)	{int l = strlen((a));fwrite(&l,1,4,fp);fwrite((a),1,l,fp);}
#define SD(a)	{double d = (a);fwrite(&d,1,sizeof(double),fp);}
#define	SV(a)	{SD((a)(0));SD((a)(1));SD((a)(2));}
#define SI(a)	{int i =(a);fwrite(&i,1,sizeof(int),fp);}

class chunk
{
protected:
	int	pos;
	FILE	*chfp;
public:
	chunk() {pos = -1;chfp = stdout;};

	void	setFile(FILE *fp)
	{
		chfp = fp;
	}
	void	writeChunk(char *cn)
	{
		fprintf(chfp,"%4s",cn);
		pos = ftell(chfp);
		printf("get len at %i\n",pos);
		fprintf(chfp,"####");
	}
	void	writeChunkLen(int l)
	{
		printf("write len at %i\n",pos);
		fseek(chfp,pos,SEEK_SET);
		fwrite(&l,1,4,chfp);
		fseek(chfp,0,SEEK_END);
	}
	void	writeChunkLen()
	{
		int	cpos,l;

		printf("write len at %i\n",pos);
		cpos = ftell(chfp);
		l = cpos - pos - 4;
		fseek(chfp,pos,SEEK_SET);
		fwrite(&l,1,4,chfp);
		fseek(chfp,0,SEEK_END);
	}
	int	getChunkLen(int l)
	{
		return l + 8;
	}
	char    *readName(FILE *fp)
	{
		int     l;
		char    *cp;

		fread(&l,1,4,fp);
		cp = (char*)malloc(l + 1);
		if(cp)
		{
			fread(cp,1,l,fp);
			cp[l] = 0;
		}

		return cp;
	}
	double readDouble(FILE *fp)
	{
		double d;
		fread(&d,1,sizeof(double),fp);
		return d;
	}
	int readInt(FILE *fp)
	{
		int i;
		fread(&i,1,sizeof(int),fp);
		return i;
	}
	Vector3 readVector(FILE *fp)
	{
		Vector3		v;
		v = Vector3(readDouble(fp), readDouble(fp), readDouble(fp));
		return v;
	}
	int	writeName(FILE *fp,char *n)
	{
		int     l;
		char    *cp;

		l = strlen(n);
		fwrite(&l,1,4,fp);
		fwrite(cp,1,l,fp);

		return 0;
	}
	char    *readName()
	{
		int     l;
		char    *cp;

		fread(&l,1,4,chfp);
		cp = (char*)malloc(l + 1);
		if(cp)
		{
			fread(cp,1,l,chfp);
			cp[l] = 0;
		}

		return cp;
	}
	double readDouble()
	{
		double d;
		fread(&d,1,sizeof(double),chfp);
		return d;
	}
	int readInt()
	{
		int i;
		fread(&i,1,sizeof(int),chfp);
		return i;
	}
	Vector3 readVector()
	{
		Vector3		v;
		v = Vector3(readDouble(chfp), readDouble(chfp), readDouble(chfp));
		return v;
	}
	int	writeName(char *n)
	{
		int     l;
		char    *cp;

		l = strlen(n);
		fwrite(&l,1,4,chfp);
		fwrite(cp,1,l,chfp);

		return 0;
	}
};


#endif


