#ifndef __FONT_H__
#define __FONT_H__

#include "glyph.h"

#include "include/ttf.h"

class font
{
protected:
	char		*name;
	char		*filename;
	char		*pathname;

	TTFontPtr	fontptr;

	fontglyph	**glyphcache;

public:
	font(char *n,char *fn = 0,char *pn = 0);
	~font();

	fontglyph	*getGlyph(char *);
	fontglyph	*getGlyph(char c);

	void		setFileName(char*);
	char		*getFileName();

private:
	int	initialize();
	void	destroy();

	fontglyph	*getCachedGlyph(char*);
	void		cacheGlyph(fontglyph *g);
};

#endif

