#ifndef __GLYPH_H__
#define __GLYPH_H__

#include <matmath.h>

class fontglyph
{
protected:
	char	*name;
	int	ncontours;	// Wieviele Konturen hat das Zeichen
	int	npoints;	// Wieviele Punkte hat das Zeichen
	Vector2	*points;
	char	*flags;		// Dieses Flag gibt zunchst nur an,
				// ob der Punkt ein on-point oder off-point ist
	int	*contours;

	double	w,h;		// Breite und Hhe des Buchstaben

public:
	fontglyph();
	fontglyph(char *n);
	fontglyph(char c);
	~fontglyph();

	void	setName(char *n);
	void	setName(char c);
	char	*getName();
	void	addPoint(Vector2 &p,int onpoint);
		
	void	addContour(int pointn);

	int	nPoints();
	int	isOnPoint(int n);
	Vector2	getPoint(int n);
	int	nContours();
	int	getContourStartPoint(int n);
	int	getContourEndPoint(int n);
	double	width();
	double	height();
	double	ascend();
	double	descend();
};

#endif


